﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class CS : System.Web.UI.Page
{
protected void DisplayFormattedDate(object sender, EventArgs e)
{
    //Convert the Date to DateTime object. Culture for dd/MM/yyyy format is en-GB.
    DateTime dt = Convert.ToDateTime(Request.Form[txtDate.UniqueID], new System.Globalization.CultureInfo("en-GB"));

    //Display the date with suffix.
    lbFormattedDate1.Text = string.Format(dt.ToString("dd{0} MMMM yyyy"), GetSuffix(dt.Day.ToString()));

    //Display the date with suffix as superscript.
    lbFormattedDate2.Text = string.Format(dt.ToString("dd{0} MMMM yyyy"), "<sup>" + GetSuffix(dt.Day.ToString()) + "</sup>");
}

private string GetSuffix(string day)
{
    string suffix = "th";

    if (int.Parse(day) < 11 || int.Parse(day) > 20)
    {
        day = day.ToCharArray()[day.ToCharArray().Length - 1].ToString();
        switch (day)
        {
            case "1":
                suffix = "st";
                break;
            case "2":
                suffix = "nd";
                break;
            case "3":
                suffix = "rd";
                break;
        }
    }

    return suffix;
}
}