﻿
Partial Class VB
    Inherits System.Web.UI.Page

    Protected Sub DisplayFormattedDate(sender As Object, e As EventArgs)
        'Convert the Date to DateTime object. Culture for dd/MM/yyyy format is en-GB.
        Dim dt As DateTime = Convert.ToDateTime(Request.Form(txtDate.UniqueID), New System.Globalization.CultureInfo("en-GB"))

        'Display the date with suffix.
        lbFormattedDate1.Text = String.Format(dt.ToString("dd{0} MMMM yyyy"), GetSuffix(dt.Day.ToString()))

        'Display the date with suffix as superscript.
        lbFormattedDate2.Text = String.Format(dt.ToString("dd{0} MMMM yyyy"), (Convert.ToString("<sup>") & GetSuffix(dt.Day.ToString())) + "</sup>")
    End Sub

    Private Function GetSuffix(day As String) As String
        Dim suffix As String = "th"

        If Integer.Parse(day) < 11 OrElse Integer.Parse(day) > 20 Then
            day = day.ToCharArray()(day.ToCharArray().Length - 1).ToString()
            Select Case day
                Case "1"
                    suffix = "st"
                    Exit Select
                Case "2"
                    suffix = "nd"
                    Exit Select
                Case "3"
                    suffix = "rd"
                    Exit Select
            End Select
        End If

        Return suffix
    End Function
End Class
